--
-- Rotation
-- Specialization for Rotation
--
-- @author Fendt-Heinz
-- @date  05.06.09
--
-- Copyright (C) Fendt-Heinz, All Rights Reserved.
--

Rotation = {};
 
function Rotation.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(motorized, specializations);
	
	
end;


function Rotation:load(xmlFile)

	local rotationPartNodeRotationTeil = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.RotationTeil#index"));
    if rotationPartNodeRotationTeil ~= nil then
        self.rotationPartRotationTeil = {};
        self.rotationPartRotationTeil.node = rotationPartNodeRotationTeil;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRotationTeil#minRot"));
        self.rotationPartRotationTeil.minRot = {};
        self.rotationPartRotationTeil.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRotationTeil.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRotationTeil.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.RotationTeil#maxRot"));
        self.rotationPartRotationTeil.maxRot = {};
        self.rotationPartRotationTeil.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRotationTeil.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRotationTeil.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRotationTeil.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.RotationTeil#rotTime"), 2)*1000;
        self.rotationPartRotationTeil.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.RotationTeil#touchRotLimit"), 10));
    end;
	

	
end;

function Rotation:keyEvent(unicode, sym, modifier, isDown)
	
		if isDown and sym == Input.KEY_5 then 
		self.rotationMaxRotationTeil = not self.rotationMaxRotationTeil;
		end;

end;


function Rotation:update(dt)

	if self.rotationPartRotationTeil ~= nil then
		local x, y, z = getRotation(self.rotationPartRotationTeil.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRotationTeil.maxRot, self.rotationPartRotationTeil.minRot, 3, self.rotationPartRotationTeil.rotTime, dt, not self.rotationMaxRotationTeil);
		setRotation(self.rotationPartRotationTeil.node, unpack(newRot));
	end;
	
	
end;

function Rotation:draw()
		if self.rotationMaxRotationTeil then	
			g_currentMission:addExtraPrintText("Taste 5: Fronthydraulik klappen");
		else
			g_currentMission:addExtraPrintText("Taste 5: Fronthydraulik klappen");
		end;
		
end;


function Rotation:onAttach()
end; 	


function Rotation:onDetach()

end;


function Rotation:delete()
	
end;


function Rotation:mouseEvent(posX, posY, isDown, isUp, button)
end;


function Rotation:aiLower()

end; 


function Rotation:aiRaise()

end; 

